zoukankan      html  css  js  c++  java
  • Halloween treats HDU 1808 鸽巢(抽屉)原理

    Halloween treats

    Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 1097    Accepted Submission(s): 435
    Special Judge


    Problem Description
    Every year there is the same problem at Halloween: Each neighbour is only willing to give a certain total number of sweets on that day, no matter how many children call on him, so it may happen that a child will get nothing if it is too late. To avoid conflicts, the children have decided they will put all sweets together and then divide them evenly among themselves. From last year's experience of Halloween they know how many sweets they get from each neighbour. Since they care more about justice than about the number of sweets they get, they want to select a subset of the neighbours to visit, so that in sharing every child receives the same number of sweets. They will not be satisfied if they have any sweets left which cannot be divided. 

    Your job is to help the children and present a solution. 

     
    Input
    The input contains several test cases. 
    The first line of each test case contains two integers c and n (1 ≤ c ≤ n ≤ 100000), the number of children and the number of neighbours, respectively. The next line contains n space separated integers a1 , ... , an (1 ≤ ai ≤ 100000 ), where ai represents the number of sweets the children get if they visit neighbour i. 

    The last test case is followed by two zeros. 

     
    Output
    For each test case output one line with the indices of the neighbours the children should select (here, index i corresponds to neighbour i who gives a total number of ai sweets). If there is no solution where each child gets at least one sweet, print "no sweets" instead. Note that if there are several solutions where each child gets at least one sweet, you may print any of them.
     
    Sample Input
    4 5 1 2 3 7 5 3 6 7 11 2 5 13 17 0 0
     
    Sample Output
    3 5 2 3 4
     
    Source
     
    Recommend
    linle   |   We have carefully selected several similar problems for you:  1802 1807 1806 1804 1801 
     
    鸽巢原理的意思是一定存在一个连续的区间,满足题目要求(是n的倍数)
    所以我们只需要求一段连续区间的和是否是n的倍数
    #include <map>
    #include <set>
    #include <stack>
    #include <cmath>
    #include <queue>
    #include <cstdio>
    #include <vector>
    #include <string>
    #include <cstring>
    #include <iomanip>
    #include <iostream>
    #include <algorithm>
    #define debug(a) cout << #a << " " << a << endl
    using namespace std;
    const int maxn = 1e5 + 10;
    const int mod = 1e9 + 7;
    typedef long long ll;
    ll vis[maxn], a[maxn];
    int main() {
        std::ios::sync_with_stdio(false);
        ll n, m;
        while( cin >> n >> m ) {
            if( !n && !m ) {
                break;
            }
            ll sum = 0, t;
            memset( vis, 0, sizeof(vis) );
            for( ll i = 1; i <= m; i ++ ) {
                cin >> a[i];
            }
            for( ll i = 1; i <= m; i ++ ) {
                sum += a[i];
                t = sum%n;
                if( t == 0 ) {
                    for( ll j = 1; j < i; j ++ ) {
                        cout << j << " ";
                    }
                    cout << i << endl;
                    break;
                } else if( vis[t] ) {  //如果余数在前面出现过,现在又出现了,则中间一定加了n的倍数
                    for( ll j = vis[t]+1; j < i; j ++ ) {
                        cout << j << " ";
                    }
                    cout << i << endl;
                    break;
                }
                vis[t] = i;
            }
        }
        return 0;
    }
    

      

    彼时当年少,莫负好时光。
  • 相关阅读:
    【JDK1.8】JDK1.8集合源码阅读——LinkedList
    【JDK1.8】JDK1.8集合源码阅读——ArrayList
    【JDK1.8】JDK1.8集合源码阅读——IdentityHashMap
    【Spring】Spring boot多数据源历险记
    【JDK1.8】JDK1.8集合源码阅读——LinkedHashMap
    还未完成的任务
    做题中的错误总结
    cdq分治学习笔记
    计算几何复习笔记
    线性基学习笔记
  • 原文地址:https://www.cnblogs.com/l609929321/p/9329683.html
Copyright © 2011-2022 走看看